from abc import ABC, abstractmethod
from datetime import datetime
from typing import Optional

from cpl_query.extension import List

from bot_data.model.user_message_count_per_hour import UserMessageCountPerHour


class UserMessageCountPerHourRepositoryABC(ABC):
    @abstractmethod
    def __init__(self):
        pass

    @abstractmethod
    def get_user_message_count_per_hours(self) -> List[UserMessageCountPerHour]:
        pass

    @abstractmethod
    def find_user_message_count_per_hour_by_user_id(self, user_id: int) -> Optional[UserMessageCountPerHour]:
        pass

    @abstractmethod
    def get_user_message_count_per_hour_by_user_id_and_date(
        self, user_id: int, date: datetime
    ) -> Optional[UserMessageCountPerHour]:
        pass

    @abstractmethod
    def find_user_message_count_per_hour_by_user_id_and_date(
        self, user_id: int, date: datetime
    ) -> Optional[UserMessageCountPerHour]:
        pass

    @abstractmethod
    def add_user_message_count_per_hour(self, umcph: UserMessageCountPerHour):
        pass

    @abstractmethod
    def update_user_message_count_per_hour(self, umcph: UserMessageCountPerHour):
        pass

    @abstractmethod
    def delete_user_message_count_per_hour(self, umcph: UserMessageCountPerHour):
        pass

    @abstractmethod
    def delete_user_message_count_per_hour_by_user_id(self, user_id: int):
        pass
