from cpl_core.database.context import DatabaseContextABC

from bot_data.model.user_history import UserHistory
from bot_graphql.abc.data_query_with_history_abc import DataQueryWithHistoryABC


class AchievementQuery(DataQueryWithHistoryABC):
    def __init__(
        self,
        db: DatabaseContextABC,
    ):
        DataQueryWithHistoryABC.__init__(self, "Achievement", "AchievementsHistory", UserHistory, db)

        self.set_field("id", lambda x: x.id)
        self.set_field("name", lambda x: x.name)
        self.set_field("attribute", lambda x: x.attribute)
        self.set_field("operator", lambda x: x.operator)
        self.set_field("value", lambda x: x.value)
        self.set_field("server", lambda x: x.server)
