import traceback

from cpl_core.configuration import ConfigurationModelABC
from cpl_core.console import Console
from cpl_query.extension import List

from modules.base.configuration.base_server_settings import BaseServerSettings


class BaseSettings(ConfigurationModelABC):
    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._servers: List[BaseServerSettings] = List()

    @property
    def servers(self) -> List[BaseServerSettings]:
        return self._servers

    def from_dict(self, settings: dict):
        try:
            servers = List(BaseServerSettings)
            for s in settings:
                st = BaseServerSettings()
                settings[s]["Id"] = s
                st.from_dict(settings[s])
                servers.append(st)
            self._servers = servers
        except Exception as e:
            Console.error(f"[ ERROR ] [ {__name__} ]: Reading error in {type(self).__name__} settings")
            Console.error(f"[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}")
